<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Player Of The Season</title>
    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="https://code.highcharts.com/modules/exporting.js"></script>
    <script src="https://code.highcharts.com/modules/export-data.js"></script>
    <script src="https://code.highcharts.com/modules/accessibility.js"></script>
    <style>
      .highcharts-figure,
      .highcharts-data-table table {
        min-width: 310px;
        max-width: 800px;
        margin: 1em auto;
      }

      #container {
        height: 400px;
      }

      .highcharts-data-table table {
        font-family: Verdana, sans-serif;
        border-collapse: collapse;
        border: 1px solid #ebebeb;
        margin: 10px auto;
        text-align: center;
        width: 100%;
        max-width: 500px;
      }
      .highcharts-data-table caption {
        padding: 1em 0;
        font-size: 1.2em;
        color: #555;
      }
      .highcharts-data-table th {
        font-weight: 600;
        padding: 0.5em;
      }
      .highcharts-data-table td,
      .highcharts-data-table th,
      .highcharts-data-table caption {
        padding: 0.5em;
      }
      .highcharts-data-table thead tr,
      .highcharts-data-table tr:nth-child(even) {
        background: #f8f8f8;
      }
      .highcharts-data-table tr:hover {
        background: #f1f7ff;
      }
    </style>
  </head>
  <body>
    <figure class="highcharts-figure">
      <div id="container"></div>
      <p class="highcharts-description">
        A basic column chart to show the player with the highest number of
        *Player of the Match* awards in each season.
      </p>
    </figure>
    <script>
      // XMLHttpRequest to issue HTTP requests
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
          var response = JSON.parse(this.responseText);
          playerOfTheSeasonChart(response);
        }
      };
      xhttp.open("GET", "http://localhost:8000/playerOfTheSeason", true);
      xhttp.send();
      // created a chart function which takes an object as a parameter
      function playerOfTheSeasonChart(obj) {
        let yearArr = Object.keys(obj);
        // series data is an array of objects.
        // Each object has 2 properties : one is name, whose value
        // is year and another property is data whose value is an
        // array of number of player of the match award received by
        // player of the season in that year
        /* Example :
           seriesData = [
             {
               name : "2008"
               data : [5, 0, 0, 0, 0, 0, 0, 0, 0]
             }
           ]
        
        */
        let seriesData = yearArr.reduce(function(arr, year) {
          let yearObj = {};
          yearObj.name = obj[year]["name"];
          let dataArr = yearArr.reduce(function(arr, element) {
            if (year === element) {
              arr.push(obj[year]["playerOfTheMatchCount"]);
            } else {
              arr.push(0);
            }
            return arr;
          }, []);
          yearObj.data = dataArr;
          arr.push(yearObj);
          return arr;
        }, []);

        Highcharts.chart("container", {
          chart: {
            type: "column"
          },
          title: {
            text: "Player of the Season with his player of the match count"
          },
          xAxis: {
            categories: Object.keys(obj),
            crosshair: true
          },
          yAxis: {
            min: 0,
            title: {
              text: "Player of The Match Count"
            }
          },
          series: seriesData
        });
      }
    </script>
  </body>
</html>
